Time Limit: 1000MS
Memory Limit: 65536K
Total Submissions: 9311
Accepted: 4039

Description

The cornfield maze is a popular Halloween treat. Visitors are shown the entrance and must wander through the maze facing zombies, chainsaw-wielding psychopaths, hippies, and other terrors on their quest
to find the exit.



One popular maze-walking strategy guarantees that the visitor will eventually find the exit. Simply choose either the right or left wall, and follow it. Of course, there's no guarantee which strategy (left or right) will be better, and the path taken is seldom
the most efficient. (It also doesn't work on mazes with exits that are not on the edge; those types of mazes are not represented in this problem.)




As the proprieter of a cornfield that is about to be converted into a maze, you'd like to have a computer program that can determine the left and right-hand paths along with the shortest path so that you can figure out which layout has the best chance of confounding
visitors.

Input

Input to this problem will begin with a line containing a single integer n indicating the number of mazes. Each maze will consist of one line with a width, w, and height, h (3 <= w, h <= 40), followed
by h lines of w characters each that represent the maze layout. Walls are represented by hash marks ('#'), empty space by periods ('.'), the start by an 'S' and the exit by an 'E'.




Exactly one 'S' and one 'E' will be present in the maze, and they will always be located along one of the maze edges and never in a corner. The maze will be fully enclosed by walls ('#'), with the only openings being the 'S' and 'E'. The 'S' and 'E' will also
be separated by at least one wall ('#').



You may assume that the maze exit is always reachable from the start point.

Output

For each maze in the input, output on a single line the number of (not necessarily unique) squares that a person would visit (including the 'S' and 'E') for (in order) the left, right, and shortest
paths, separated by a single space each. Movement from one square to another is only allowed in the horizontal or vertical direction; movement along the diagonals is not allowed.

Sample Input

2
8 8
########
#......#
#.####.#
#.####.#
#.####.#
#.####.#
#...#..#
#S#E####
9 5
#########
#.#.#.#.#
S.......E
#.#.#.#.#
#########

Sample Output

37 5 5
17 17 9

1.题意:有一个迷宫,#代表墙,..代表能走。S是起点。E是终点W为宽。列数H为高。

先输出左转优先时。从S到E的步数

再输出右转优先时,从S到E的步数

最后输出S到E的最短步数

自己写的有非常多问题。。

后面我发现别人都是用什么数学方法来确定向左还是向右。。我立即就Orz了。

那些人里面。写的最好的就是这个了点击打开链接

。尼玛,又看了结题报告。。╮(╯▽╰)╭。。

简直丧心病狂。。剁手。。。好吧。。题外话就不多说了。。。其它的他都说的非常具体了。

。。我也就

打打酱油吧。。。。。。。。

Orz。。。。。。

。。。


#include<cstdio>
#include<iostream>
#include<cstring>
#include<queue>
#include<algorithm>
#include<vector> using namespace std; const int N = 105; char map[N][N];
int vist[N][N]; struct node
{
int x;
int y;
int num;
};
queue<node>q;
node first; int dx[4]={1,-1,0,0};
int dy[4]={0,0,-1,1};
int fx[]= {0,1,0,-1};
int fy[]= {1,0,-1,0};
int fr[]= {1,0,3,2};
int fl[]= {3,0,1,2};
int ans;
int t, n, m;
int xx, yy;
int d; void L_dfs(int x, int y, int d) //靠左墙
{
ans++;
if( map[x][y] == 'E' )
{
printf( "%d", ans );
ans = 0; //记得初始
return ;
}
for(int i=0; i<4; i++)
{
int j = ( d + fl[i] ) % 4;
xx = x + fx[j];
yy = y + fy[j];
if(xx>=1 && xx<=n && yy>=1 && yy<=m && map[xx][yy]!='#')
{
L_dfs(xx, yy, j);
return ; //少了直接爆掉
}
} } void R_dfs(int x, int y, int d) //向右
{
ans++;
if( map[x][y] == 'E' )
{
printf(" %d", ans );
ans = 0;
return ;
}
for(int i=0; i<4; i++)
{
int j= ( d + fr[i] ) % 4;
xx = x + fx[j];
yy = y + fy[j];
if(xx>=1 && xx<=n && yy>=1 && yy<=m && map[xx][yy]!='#')
{
R_dfs(xx, yy, j);
return ;
}
} } void S_bfs() //最短路径
{
memset( vist, false, sizeof( vist ) );
vist[first.x][first.y] = true;
while( !q.empty() )
{
node temp = q.front();
q.pop();
if( map[temp.x][temp.y]=='E' )
{
printf(" %d\n", temp.num+1);
break;
}
for(int i=0; i<4; i++)
{ xx = temp.x + dx[i];
yy = temp.y + dy[i];
if( xx>=1 && xx<=n &&yy>=1 &&yy<=m && !vist[xx][yy] && map[xx][yy]!='#' )
{
node next;
next.x = xx;
next.y = yy;
next.num = temp.num + 1;
vist[xx][yy] = true;
q.push( next );
}
}
}
} int main()
{
scanf("%d\n", &t);
while( t-- )
{
memset( vist, false, sizeof( vist ) );
while( !q.empty() ) q.pop();
scanf("%d%d", &m, &n);
for(int i=1; i<=n; i++)
for(int j=1; j<=m; j++)
{
cin>>map[i][j];
if( map[i][j]=='S' )
{
first.x = i;
first.y = j;
}
}
first.num = 0; ans = 0;
vist[first.x][first.y] = true;
q.push( first );
if(first.x==1) d=0;
if(first.x==n) d=2;
if(first.y==1) d=1;
if(first.y==m) d=3;
L_dfs( first.x, first.y, d);
R_dfs( first.x, first.y, d);
S_bfs();
} return 0;
}

POJ 3083:Children of the Candy Corn(DFS+BFS)的更多相关文章

  1. POJ 3083 -- Children of the Candy Corn(DFS+BFS)TLE

    POJ 3083 -- Children of the Candy Corn(DFS+BFS) 题意: 给定一个迷宫,S是起点,E是终点,#是墙不可走,.可以走 1)先输出左转优先时,从S到E的步数 ...

  2. poj 3083 Children of the Candy Corn(DFS+BFS)

    做了1天,总是各种错误,很无语 最后还是参考大神的方法 题目:http://poj.org/problem?id=3083 题意:从s到e找分别按照左侧优先和右侧优先的最短路径,和实际的最短路径 DF ...

  3. POJ 3083:Children of the Candy Corn

    Children of the Candy Corn Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11015   Acce ...

  4. poj 3083 Children of the Candy Corn (广搜,模拟,简单)

    题目 靠墙走用 模拟,我写的是靠左走,因为靠右走相当于 靠左走从终点走到起点. 最短路径 用bfs. #define _CRT_SECURE_NO_WARNINGS #include<stdio ...

  5. POJ3083 Children of the Candy Corn(搜索)

    题目链接. 题意: 先沿着左边的墙从 S 一直走,求到达 E 的步数. 再沿着右边的墙从 S 一直走,求到达 E 的步数. 最后求最短路. 分析: 最短路好办,关键是沿着墙走不太好想. 但只要弄懂如何 ...

  6. POJ3083 Children of the Candy Corn(Bfs + Dfs)

    题意:给一个w*h的迷宫,其中矩阵里面 S是起点,E是终点,“#”不可走,“.”可走,而且,S.E都只会在边界并且,不会在角落,例如(0,0),输出的话,每组数据就输出三个整数,第一个整数,指的是,以 ...

  7. POJ-3083 Children of the Candy Corn (BFS+DFS)

    Description The cornfield maze is a popular Halloween treat. Visitors are shown the entrance and mus ...

  8. POJ 2739:Sum of Consecutive Prime Numbers(Two pointers)

    [题目链接] http://poj.org/problem?id=2739 [题目大意] 求出一个数能被拆分为相邻素数相加的种类 [题解] 将素数筛出到一个数组,题目转化为求区段和等于某数的次数,尺取 ...

  9. 题解报告:hdu 2612 Find a way(双bfs)

    Problem Description Pass a year learning in Hangzhou, yifenfei arrival hometown Ningbo at finally. L ...

随机推荐

  1. python--fnmatch

    import fnmatch ''' 这个库专门是用来做文件名匹配的,可以使用通配符如下 * 匹配任何数量的任意字符 ? 匹配单个数量的任意字符 [seq] 匹配seq中的任意字符 [!seq] 匹配 ...

  2. text-shadow

    text-shadow,文字阴影,通过text-shadow不使用ps可以实现文字阴影特效,可以让页面变得更加美观. text-shadow语法 text-shadow : none | <le ...

  3. Ajaxterm + nginx 实现一个简单的堡垒机

    https://blog.csdn.net/zhang19771105/article/details/50497581 http://wuliangxx.iteye.com/blog/600113

  4. [libGDX游戏开发教程]使用Libgdx进行游戏开发(5)-关卡加载

    在上一章我们介绍了如何管理和利用素材,但是我们注意到,这些素材都是零散的,比如岩石的左部等,这一章,我们将利用这些零件拼合成完整的游戏对象. 回顾最开始的设计类图,注意Level类和所有Level中的 ...

  5. 洛谷 P1316 丢瓶盖【二分答案】

    题目描述 陶陶是个贪玩的孩子,他在地上丢了A个瓶盖,为了简化问题,我们可以当作这A个瓶盖丢在一条直线上,现在他想从这些瓶盖里找出B个,使得距离最近的2个距离最大,他想知道,最大可以到多少呢? 输入输出 ...

  6. Maven学习笔记2

    Maven安装配置 1.下载Maven 官方地址:http://maven.apache.org/download.cgi 将下载的压缩包解压到你要安装 Maven 的文件夹.假设你解压缩到文件夹 – ...

  7. java 面向接口编程的理解

    初学者可能在学习中会有很多疑惑,为什么要这样,明明可以那样实现,这样做的好处又是什么? 可能会的人觉得很简单很容易理解,甚至可能觉得问的问题很智障,但对于小白来说可能是苦思冥想都不得其解的. 自己身为 ...

  8. Exercise03_03

    import java.util.Scanner; public class LinearEquation { public static void main(String[] args){ doub ...

  9. Problem O: 逆序输出——C语言初学者百题大战之二十

    #include<stdio.h> int main() { int a,b,c,d,e,n; scanf("%d",&n); a=n/; b=n%/; c=n ...

  10. 如何设断点????-----使用WinDbg调试SQL Server查询

    http://www.cnblogs.com/woodytu/p/4665427.html http://www.sqlservercentral.com/blogs/aschenbrenner/20 ...